﻿namespace Microsoft.Ceres.Optimizer.Engine
{
    /// <summary>
    /// Requesting a bit set hapens before the bit sets have been minimized and the bit set manager prepared.
    /// Clients who requests a bit set will therefore be given a proxy instead,
    /// and the bit set  manager will set the bit set instance on this proxy after preparation.
    /// </summary>
    public class BitSetProxy
    {
        /// <summary>BitSet instance set by the bit set manager after preparation.</summary>
        public BitSet BitSet { get; set; }
        /// <summary>If this bit set is produced, required or none.</summary>
        public PropertyUsage PropertyUsage { get; set; }
        /// <summary>Properties for the requested bit set.</summary>
        public NestableHashSet<string> Properties { get; set; }

        public override string ToString()
        {
            return string.Format("{0}, {1}", PropertyUsage, Properties);
        }
    }
}