﻿#region

using System;
using System.Collections.Generic;

#endregion

namespace Microsoft.Ceres.Optimizer.Engine.Orders
{
    internal class OrderTemplate
    {
        public OrderDescription OrderDescription { get; set; }
        public int MaxRelevant { get; set; }

        public int RelevantLength(OrderDescription insertInto, int insertAt, string valueToInsert,
                                  Dictionary<string, string> propertyMap)
        {
            valueToInsert = propertyMap[valueToInsert];
            int pos = 0;
            for (int i = 0; i < insertAt; i++)
            {
                string property = propertyMap[insertInto[i].Property];
                while (pos < OrderDescription.Size && OrderDescription[pos].Property != property)
                    ++pos;
                if (pos >= OrderDescription.Size)
                    return i;
            }

            while (pos < OrderDescription.Size && OrderDescription[pos].Property != valueToInsert)
                ++pos;

            if (pos >= OrderDescription.Size)
                return insertAt;

            for (int i = insertAt; i < insertInto.Size; i++)
            {
                string property = propertyMap[insertInto[i].Property];
                while (pos < OrderDescription.Size && OrderDescription[pos].Property != property)
                    ++pos;
                if (pos >= OrderDescription.Size)
                    return i + 1;
            }
            return Math.Min(OrderDescription.Size + 1, insertInto.Size + 1);
        }

        public override string ToString()
        {
            return string.Format("Desc: {0}, MaxRelevant: {1}", OrderDescription, MaxRelevant);
        }
    }
}