﻿namespace Microsoft.Ceres.Optimizer.Engine.Orders
{
    /// <summary>
    /// Base class for ordering and grouping proxies.
    /// Requesting an ordering or grouping happens before the Order instances have been construced.
    /// Clients who requests an ordering or grouping will therefor be given a proxy instead,
    /// and the order manager will set the Order instance on this proxy after preparation.
    /// </summary>
    public class Proxy
    {
        /// <summary>Id of this proxy.</summary>
        public int Id { get; set; }
        /// <summary>Order instance which will be set by the optimizer after FSM construction.</summary>
        public Order Order { get; set; }
        /// <summary>If this ordering or grouping is produced.</summary>
        public bool Produced { get; set; }
    }
}