﻿#region

using System;
using System.Diagnostics;

#endregion

namespace Microsoft.Ceres.Optimizer.Engine
{
    /// <summary>
    /// Utility class for timing the different steps during an optimization.
    /// </summary>
    internal class StopWatchTimer
    {
        private readonly Stopwatch watch = new Stopwatch();
        private TimeSpan lastElapsed = TimeSpan.Zero;

        public bool Enabled { get; set; }

        public void Start()
        {
            watch.Start();
        }

        public void Stop()
        {
            watch.Stop();
        }

        public void PrintIntermediatePoint(string format)
        {
            if (Enabled)
                DiagPrinter.Instance.InfoWriteLine("stats", format, watch.Elapsed - lastElapsed);
            lastElapsed = watch.Elapsed;
        }

        public void PrintTotal(string format)
        {
            if (Enabled)
                DiagPrinter.Instance.InfoWriteLine("stats", format, watch.Elapsed);
        }
    }
}