﻿namespace Microsoft.Ceres.Optimizer.GraphMatching
{
    /// <summary>
    /// Matcher that takes an arbitrary LINQ-expression and uses it for matching.
    /// </summary>
    public class ExpressionMatcher : AbstractNodeMatcher
    {
        #region Delegates

        public delegate bool ExpressionDelegate(Node node);

        #endregion

        public ExpressionDelegate Expression;

        public ExpressionMatcher(ExpressionDelegate expression)
        {
            Name = "Expression";
            Expression = expression;
        }

        public override bool Search(Node node)
        {
            if (!Expression(node))
                return HasMatched = false;

            MatchedNodes.Add(node);
            return HasMatched = true;
        }

        public override string ToString()
        {
            return string.Format("Expression", Expression.ToString());
        }
    }
}