﻿namespace Microsoft.Ceres.Optimizer.GraphMatching
{
    /// <summary>
    /// Class that only provides some sugar for instantiating patterns.
    /// </summary>
    public static class Match
    {
        public static AbstractNodeMatcher NodeOfType(string type)
        {
            return new NodeTypeMatcher(type);
        }

        public static AbstractNodeMatcher NodeWithName(string name)
        {
            return new NamedNodeMatcher(name);
        }

        public static AbstractNodeMatcher NodeWithBehaviour(OperatorBehaviour behaviour)
        {
            return new NodeBehaviourMatcher(behaviour);
        }

        public static AbstractNodeMatcher AnyNode()
        {
            return new AnythingMatcher();
        }

        public static AbstractNodeMatcher All(AbstractNodeMatcher pattern)
        {
            return new AllMatcher(pattern);
        }
    }
}