﻿namespace Microsoft.Ceres.Optimizer.GraphMatching
{
    /// <summary>
    /// MatchGrouper simply attaches a name to a sub-pattern. It is used to access named results in GraphSearchers.
    /// </summary>
    public class MatchGrouper : MatcherWrapper
    {
        public readonly string GroupName;

        public MatchGrouper(string groupName, AbstractNodeMatcher subPattern)
        {
            GroupName = groupName;
            AddChild(subPattern);
        }

        public override bool Search(Node node)
        {
            if (! Pattern.Search(node))
                return HasMatched = false;

            MatchedNodes.Add(node);
            return HasMatched = true;
        }

        public override string ToString()
        {
            return string.Format("Group<{0}>({1})", GroupName, Pattern.ToString());
        }
    }
}