﻿namespace Microsoft.Ceres.Optimizer.GraphMatching
{
    /// <summary>
    /// Utility methods for matcher's that wrap a sub-pattern.
    /// </summary>
    public abstract class MatcherWrapper : AbstractNodeMatcher
    {
        public AbstractNodeMatcher Pattern
        {
            get { return (AbstractNodeMatcher) OnlyChild; }
        }

        public bool HasPattern
        {
            get { return Children.Count == 1; }
        }

        public override bool HasMatched
        {
            get { return Pattern.HasMatched; }
            set
            {
                if (HasPattern)
                    Pattern.HasMatched = value;
            }
        }

        public override void Reset()
        {
            base.Reset();
            if (HasPattern)
                Pattern.Reset();
        }

        public override string ToString()
        {
            return string.Format("{0}({1})", Name, Pattern);
        }
    }
}