﻿namespace Microsoft.Ceres.Optimizer.GraphMatching
{
    /// <summary>
    /// Matcher that checks the node's name. Mostly used for testing.
    /// </summary>
    public class NamedNodeMatcher : AbstractNodeMatcher
    {
        private readonly string expectedName;

        public NamedNodeMatcher(string name)
        {
            Name = name;
            expectedName = name;
        }

        public override bool Search(Node node)
        {
            if (node.Name != expectedName)
                return HasMatched = false;

            MatchedNodes.Add(node);
            return HasMatched = true;
        }

        public override string ToString()
        {
            return string.Format("Name<{0}>", expectedName);
        }
    }
}