﻿namespace Microsoft.Ceres.Optimizer.GraphMatching
{
    /// <summary>
    /// Matcher that checks the node's behaviour.
    /// </summary>
    public class NodeBehaviourMatcher : AbstractNodeMatcher
    {
        public NodeBehaviourMatcher(OperatorBehaviour behaviour)
        {
            MatchingBehaviour = behaviour;
        }

        public OperatorBehaviour MatchingBehaviour { get; private set; }

        public override bool Search(Node node)
        {
            OperatorNode operatorNode = node as OperatorNode;
            HasMatched = operatorNode != null && (operatorNode.Behaviour & MatchingBehaviour) == MatchingBehaviour;
            if (HasMatched)
                MatchedNodes.Add(node);

            return HasMatched;
        }
    }
}