﻿#region

using System.Collections.Generic;
using System.Linq;

#endregion

namespace Microsoft.Ceres.Optimizer.GraphMatching
{
    /// <summary>
    /// Matcher that matches nodes of the provided type.
    /// </summary>
    public class NodeTypeMatcher : AbstractNodeMatcher
    {
        public NodeTypeMatcher(string typeName)
        {
            MatchType = typeName;
        }

        public string MatchType { get; set; }

        public override bool Search(Node node)
        {
            HasMatched = false;
            OperatorNode operatorNode = node as OperatorNode;
            if (operatorNode == null || operatorNode.OperatorType == null)
                return HasMatched = false;

            HasMatched = operatorNode.OperatorType.Name.Contains(MatchType);
            if (!HasMatched)
                return false;

            MatchedNodes.Add(node);
            return true;
        }

        public override string ToString()
        {
            return string.Format("NodeOfType({0})", MatchType);
        }
    }
}