﻿namespace Microsoft.Ceres.Optimizer
{
    public class NodeAttribute : Pair<OperatorNode, string>
    {
        /// <summary>
        /// Referring to an attribute by name is not sufficient. This class wraps both the name of the attribute and the node producing it.
        /// </summary>
        /// <param name="node"></param>
        /// <param name="attributeName"></param>
        public NodeAttribute(OperatorNode node, string attributeName) : base(node, attributeName)
        {
        }

        public OperatorNode Node { get; set; }
        public string AttributeName { get; set; }

        public override OperatorNode First
        {
            get { return Node; }
            set { Node = value; }
        }

        public override string Second
        {
            get { return AttributeName; }
            set { AttributeName = value; }
        }

        public string PropertyName
        {
            get
            {
                if (AttributeName != null)
                    return string.Format("AT_{0}_{1}", Node.Id, AttributeName);
                else
                    return string.Format("AP_{0}", Node.Id);
            }
        }
    }
}