﻿#region

using Microsoft.Ceres.Optimizer.Engine;
using Microsoft.Ceres.Optimizer.Preprocessors;
using Microsoft.Ceres.Optimizer.Rules.Infrastructure;

#endregion

namespace Microsoft.Ceres.Optimizer.Postprocessors
{
    /// <summary>
    /// Converts NodeAttribute references to field names before returning the query to MARS.
    /// </summary>
    [Postprocessor]
    public class FieldAnnotator : AbstractAnnotator<IFieldMapper>
    {
        public override void Annotate(OperatorNode root)
        {
            foreach (OperatorNode node in root.GetTopologicalOrdering())
                if (mapperForType.ContainsKey(node.OperatorType))
                    mapperForType[node.OperatorType].SetFields(queryOptimization, node);
                else
                    throw new OptimizerException("Operator type {0} does not have a field mapper.", node.OperatorType);
        }
    }
}