﻿#region

using Microsoft.Ceres.Optimizer.Engine;

#endregion

namespace Microsoft.Ceres.Optimizer.Rules.Infrastructure
{
    /// <summary>
    /// Base rules produces properties, but do not required input. Hence, they have no searching capabilities.
    /// </summary>
    public interface IBaseRule : IProducerRule
    {
        /// <summary>
        /// Initialize a plan set with properties from the rule, like tuple size, cardinality etc.
        /// </summary>
        /// <param name="plans">The plan set to initialize.</param>
        void Initialize(PlanSet plans);
    }
}