﻿namespace Microsoft.Ceres.Optimizer.Rules.Infrastructure
{
    /// <summary>
    /// Sets the operator's dependencies.
    /// </summary>
    public interface IDependencyMapper : IMapper
    {
        /// <summary>
        /// This method is called on the corresponding mapper for all nodes in the query in
        /// topological order and should set the node's dependencies.
        /// </summary>
        /// <param name="node">The node to set dependencies for.</param>
        void SetDependencies(OperatorNode node);
    }
}