﻿#region

using System.Collections.Generic;

#endregion

namespace Microsoft.Ceres.Optimizer.Rules.Infrastructure
{
    /// <summary>
    /// Marks which attributes are deemed
    /// equivalent. For example, an equi-join of two attributes will induce
    /// that the two are equivalent. 
    /// </summary>
    public interface IEquivalenceMapper : IMapper
    {
        /// <summary>
        /// This method is called on the corresponding mapper for all nodes in the query in
        /// topological order and should get the quivalences for the node.
        /// </summary>
        /// <param name="node">The node to get equivalences for.</param>
        /// <returns>A sequence of sets of equivalent attributes.</returns>
        IEnumerable<HashSet<NodeAttribute>> GetEquivalences(OperatorNode node);
    }
}