﻿#region

using Microsoft.Ceres.Optimizer.Engine;

#endregion

namespace Microsoft.Ceres.Optimizer.Rules.Infrastructure
{
    /// <summary>
    /// Converts NodeAttribute references to field names before returning the query to MARS.
    /// </summary>
    public interface IFieldMapper : IMapper
    {
        /// <summary>
        /// This method is called on the corresponding mapper for all nodes in the query in
        /// topological order and should set field names for all NodeAttributes in the nodes
        /// output using OperatorNode's RecordDescriptor property. It should also convert
        /// all NodeAttribute references to field names.
        /// </summary>
        /// <param name="queryOptimization">The current instance of QueryOptimization.</param>
        /// <param name="node">The node to set field names for.</param>
        void SetFields(QueryOptimization queryOptimization, OperatorNode node);
    }
}