﻿#region

using Microsoft.Ceres.Optimizer.GraphMatching;
using NUnit.Framework;

#endregion

namespace Microsoft.Ceres.Optimizer.Tests.GraphMatching
{
    /// <summary>
    /// Extensions to aid in testing the graph matcher.
    /// </summary>
    public static class Extensions
    {
        public static void AssertMatches(this AbstractNodeMatcher pattern, Node node)
        {
            pattern.Reset();
            Assert.That(pattern.Search(node) && pattern.HasMatched, "Pattern {0} did not match {1}", pattern, node);
        }

        public static void AssertMatches(this AbstractNodeMatcher pattern, params Node[] nodes)
        {
            foreach (Node node in nodes)
            {
                pattern.AssertMatches(node);
            }
        }

        public static void AssertNotMatches(this AbstractNodeMatcher pattern, Node node)
        {
            pattern.Reset();
            Assert.That(! (pattern.Search(node) || pattern.HasMatched), "Pattern {0} unexpectedly matches {1}", pattern,
                        node);
        }

        public static void AssertNotMatches(this AbstractNodeMatcher pattern, params Node[] nodes)
        {
            foreach (Node node in nodes)
            {
                pattern.AssertNotMatches(node);
            }
        }
    }
}