﻿#region

using Microsoft.Ceres.Evaluation.Operators;
using Microsoft.Ceres.Evaluation.Operators.Parsing;
using Microsoft.Ceres.Evaluation.Processing;
using Microsoft.Ceres.SearchCore.Services.SystemCatalog;

#endregion

namespace Microsoft.Ceres.Optimizer.Transformer
{
    /// <summary>
    /// Evaluator binder for the optimizer evaluator.
    /// </summary>
    [EvalBinder, EvalBinderOperator(typeof (OptimizerTransformerOperator))]
    public class OptimizerTransformerEvaluatorBinder : AbstractEvaluatorBinder
    {
        public IOperatorDecorator OperatorDecorator { get; set; }

        public ISystemCatalog Catalog { get; set; }

        public override Evaluator BindEvaluator(OperatorBase op, IEvaluationContext context)
        {
            if (op is OptimizerTransformerOperator)
            {
                return new OptimizerTransformerEvaluator() {OperatorDecorator = OperatorDecorator, Catalog = Catalog};
            }
            return null;
        }
    }
}