﻿#region

using Microsoft.Ceres.CoreServices.Services.Container;
using Microsoft.Ceres.CoreServices.Services.DependencyInjection;
using Microsoft.Ceres.CoreServices.Services.Node;
using Microsoft.Ceres.Evaluation.Operators.Parsing;
using Microsoft.Ceres.Evaluation.Processing;
using Microsoft.Ceres.SearchCore.Services.SystemCatalog;

#endregion

namespace Microsoft.Ceres.Optimizer.Transformer
{
    /// <summary>
    /// Evaluator binder source for the optimizer evaluator.
    /// </summary>
    [DynamicComponent]
    public class OptimizerTransformerEvaluatorBinderSource : AbstractContainerManaged
    {
        private OptimizerTransformerEvaluatorBinder optimizerBinder;


        [Exposed]
        public IEvaluatorBinder OptimizerTransformerEvaluatorBinder
        {
            get
            {
                if (optimizerBinder == null)
                    optimizerBinder = new OptimizerTransformerEvaluatorBinder()
                                          {OperatorDecorator = OperatorDecorator, Catalog = Catalog};
                return optimizerBinder;
            }
        }

        [Injected(Optional = false)]
        public IOperatorDecorator OperatorDecorator { get; set; }

        [Injected(Optional = false)]
        public ISystemCatalog Catalog { get; set; }
    }
}