﻿#region

using System.Collections.Generic;
using Microsoft.Ceres.Evaluation.Operators;
using Microsoft.Ceres.Evaluation.Operators.Graphs;
using Microsoft.Ceres.Evaluation.Operators.Utilities;

#endregion

namespace Microsoft.Ceres.Optimizer.Transformer
{
    /// <summary>
    /// Query chain operator for the optimizer.
    /// </summary>
    [Operator("OptimizerTransformer")]
    public class OptimizerTransformerOperator : TypedOperatorBase<OptimizerTransformerOperator>
    {
        /// <inheritdoc />
        protected override void ValidateAndType(OperatorStatus status, IList<Edge> inputEdges)
        {
            if (ValidationUtils.ValidateInputFieldExists(status, "querycontext", inputEdges))
            {
                status.SetSingleOutput(inputEdges[0].RecordSetType);
            }
        }
    }
}